#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

#undef REQUIRE_PLUGIN

#define PLUGIN_VERSION "1.0.7"

public Plugin:myinfo =
{
	name = "C4 Christmas Bomb",
	author = "Mitch, Lacrimosa99, GeNeRaLbEaM",
	description = "Changes the default C4 Model to Server Side Christmas Bomb.",
	version = PLUGIN_VERSION,
	url = "http://snbx.info/, http://www.devil-hunter-multigaming.de/, http://www.dust-fighter.de/"
};

enum C4Characteristics
{
	String:Model[512],
	Float:Size
};
new C4Prop[C4Characteristics];

new Handle:C4Model = INVALID_HANDLE;
new Handle:C4Size = INVALID_HANDLE;


public OnPluginStart()
{
	C4Model = CreateConVar("c4_model", "models/weapons/GeNeRaLbEaM/c4/w_c4_planted.mdl", "Model for C4 bomb.");
	C4Size = CreateConVar("c4_size", "1.0", "Size of the C4 Model.", 0, true, 0.1, true, 10.0);
	HookEvent("bomb_planted", BomPlanted_Event);
	HookConVarChange(C4Model, ConvarChange_c4);
	HookConVarChange(C4Size, ConvarChange_c4);
}

public ConvarChange_c4(Handle:cvar, const String:oldVal[], const String:newVal[]) {
	GetConVarString(C4Model, C4Prop[Model], 512);
	if(!StrEqual(C4Prop[Model], "")) PrecacheModel(C4Prop[Model], false);
	C4Prop[Size] = GetConVarFloat(C4Size);
}

public OnAllPluginsLoaded() {
	CreateConVar("sm_c4_christmas_bomb_version", PLUGIN_VERSION, "C4 Christmas Bomb Version", FCVAR_DONTRECORD|FCVAR_NOTIFY);	
}

public OnConfigsExecuted()
{
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.dx80.vtx");
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.dx90.vtx");
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.mdl");
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.sw.vtx");
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.vvd");
	AddFileToDownloadsTable("models/weapons/GeNeRaLbEaM/c4/w_c4_planted.xbox.vtx");
	AddFileToDownloadsTable("materials/models/weapons/GeNeRaLbEaM/c4/w_c4.vmt");
	AddFileToDownloadsTable("materials/models/weapons/GeNeRaLbEaM/c4/w_c4.vtf");

	GetConVarString(C4Model, C4Prop[Model], 512);
	if(!StrEqual(C4Prop[Model], "")) PrecacheModel(C4Prop[Model], true);
	C4Prop[Size] = GetConVarFloat(C4Size);
}

public Action:BomPlanted_Event(Handle:event, const String:name[], bool:dontBroadcast)
{
	new c4 = -1;
	c4 = FindEntityByClassname(c4, "planted_c4");
	if(c4 != -1)
	{
		if((!StrEqual(C4Prop[Model], "")) || (!StrEqual(C4Prop[Model], "models/weapons/GeNeRaLbEaM/c4/w_c4_planted.mdl")))
			SetEntityModel(c4, C4Prop[Model]);
		if(C4Prop[Size] != 1.0)
			SetEntPropFloat(c4, Prop_Send, "m_flModelScale", C4Prop[Size]);
	}
	return Plugin_Continue;
}